diff -urN src/gtk2/gui/guiUsers.ml src/gtk2/gui/guiUsers.ml
--- src/gtk2/gui/guiUsers.ml	2005-03-02 20:45:12.000000000 +0100
+++ src/gtk2/gui/guiUsers.ml	2005-09-17 14:44:32.000000000 +0200
@@ -42,19 +42,66 @@
 
 (*************************************************************************)
 (*                                                                       *)
+(*                         user_num                                      *)
+(*                                                                       *)
+(*************************************************************************)
+
+let user_num key =
+  try int_of_string key with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         user_of_key                                   *)
+(*                                                                       *)
+(*************************************************************************)
+
+let user_of_key key =
+  try
+    let num = user_num key in
+    Hashtbl.find G.users num
+  with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         keys_to_users                                 *)
+(*                                                                       *)
+(*************************************************************************)
+
+let keys_to_users keys =
+  let l = ref [] in
+  List.iter (fun k ->
+    try
+      let s = user_of_key k in
+      l := s :: !l
+    with _ -> ()) keys;
+  !l
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         user_key                                      *)
+(*                                                                       *)
+(*************************************************************************)
+
+let user_key user_num =
+  Printf.sprintf "%d" user_num
+
+(*************************************************************************)
+(*                                                                       *)
 (*                         message to the core                           *)
 (*                                                                       *)
 (*************************************************************************)
-    
+
 let add_to_friends sel ()  =
+  let l = keys_to_users sel in
   List.iter (fun u ->
     GuiCom.send (AddUserFriend u.user_num)
-  ) sel
+  ) l
 
 let browse_files sel () =
+  let l = keys_to_users sel in
   List.iter (fun u ->
     GuiCom.send (BrowseUser u.user_num)
-  ) sel
+  ) l
 
 
 (*************************************************************************)
@@ -63,7 +110,7 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let user_menu (sel : user_info list) =
+let user_menu sel =
   match sel with
       [] -> []
     | _ ->
@@ -72,6 +119,16 @@
            `I (!M.rT_me_browse_files, browse_files sel) ;
           ]
 
+(*************************************************************************)
+(*                                                                       *)
+(*                         hashtbl_users_update                          *)
+(*                                                                       *)
+(*************************************************************************)
+
+let hashtbl_users_update u u_new =
+  u.user_tags <- u_new.user_tags
+
+
 module UserList(R:
 
 (*************************************************************************)
@@ -104,16 +161,14 @@
       module Column = GuiColumns.User
 
       type item = user_info
-      type key = int
 
       let columns = R.columns
-      let get_key = (fun u -> u.user_num)
+      let get_key = (fun u -> user_key u.user_num)
       let module_name = R.module_name
     end)
 
     class g_user () =
       let user_cols     = new GTree.column_list in
-      let user_num      = user_cols#add Gobject.Data.int in
       let user_name     = user_cols#add Gobject.Data.string in
       let user_md4      = user_cols#add Gobject.Data.string in
       let user_ip_port  = user_cols#add Gobject.Data.string in
@@ -129,7 +184,6 @@
 (*************************************************************************)
 
         method from_item row (u : user_info) =
-          store#set ~row ~column:user_num u.user_num;
           store#set ~row ~column:user_name (U.utf8_of u.user_name);
           store#set ~row ~column:user_ip_port (Mi.ip_to_string u.user_ip u.user_port);
           store#set ~row ~column:user_md4 (Md4.to_string u.user_md4);
@@ -200,12 +254,16 @@
 (*                                                                       *)
 (*************************************************************************)
 
-        method sort_items c u1 u2 =
-          match c with
+        method sort_items c k1 k2 =
+          try
+            let u1 = user_of_key k1 in
+            let u2 = user_of_key k2 in
+            match c with
               Col_user_name -> compare (String.lowercase u1.user_name) (String.lowercase u2.user_name)
             | Col_user_addr -> compare u1.user_ip u2.user_ip
             | Col_user_tags -> compare u1.user_tags u2.user_tags
             | Col_user_md4 -> compare u1.user_md4 u2.user_md4
+          with _ -> 0
 
       end
 
diff -urN src/gtk2/gui/guiUtf8.ml src/gtk2/gui/guiUtf8.ml
--- src/gtk2/gui/guiUtf8.ml	2005-03-02 20:45:12.000000000 +0100
+++ src/gtk2/gui/guiUtf8.ml	2005-10-23 14:28:52.000000000 +0200
@@ -724,7 +724,7 @@
   enc_list := List.filter (fun enc -> enc <> charset) !enc_list;
   enc_list := if (charset <> "UTF-8") then charset::!enc_list else !enc_list;
   List.iter (fun enc ->
-    Printf.printf "Use encoding %s\n" enc; 
+    Printf2.lprintf "Use encoding %s\n" enc; 
     flush stdout
   ) !enc_list;
   nenc := List.length !enc_list
diff -urN src/gtk2/gui/guiWindow.ml src/gtk2/gui/guiWindow.ml
--- src/gtk2/gui/guiWindow.ml	2005-04-04 21:36:46.000000000 +0200
+++ src/gtk2/gui/guiWindow.ml	2005-10-01 10:27:20.000000000 +0200
@@ -144,10 +144,10 @@
 (*                                                                       *)
 (*************************************************************************)
 
-(* TODO *)
-
 let display_graph gui () =
   clean gui.vbox;
+  let graph = GuiGraph.graph_box gui in
+  gui.vbox#add graph;
   gui.current_page <- 8
 
 (*************************************************************************)
@@ -217,6 +217,12 @@
       ~icon:(A.get_icon ~icon:M.icon_menu_console ~size:A.LARGE ())
       ~f:(display_console gui) ()
   in
+  let bGraph = gui.wtool#add_toggle_button
+      ~style:!!O.gtk_look_toolbars_style
+      ~markup:!M.mW_lb_graph
+      ~icon:(A.get_icon ~icon:M.icon_menu_graph ~size:A.LARGE ())
+      ~f:(display_graph gui) ()
+  in
 (*
  * TODO : make a Graph tab + some stats
  *
@@ -250,9 +256,7 @@
       | 5 -> bRooms#set_active true
       | 6 -> bUploads#set_active true
       | 7 -> bConsole#set_active true
-(*
       | 8 -> bGraph#set_active true
-*)
       | _ -> bDownloads#set_active true
   );
   gui.update_current_page <- (fun _ ->
@@ -264,9 +268,7 @@
       | 5 -> display_rooms gui ()
       | 6 -> display_uploads gui ()
       | 7 -> display_console gui ()
-(*
       | 8 -> display_graph gui ()
-*)
       | _ -> display_downloads gui ()
   )
 
@@ -342,4 +344,4 @@
   vbox#pack ~expand:false ~fill:true statusbar;
 
   gui
-      
+
diff -urN src/gtk2/im/guiImAccounts.ml src/gtk2/im/guiImAccounts.ml
--- src/gtk2/im/guiImAccounts.ml	2005-03-02 21:16:53.000000000 +0100
+++ src/gtk2/im/guiImAccounts.ml	2005-09-18 17:17:20.000000000 +0200
@@ -25,7 +25,7 @@
 open ImTypes
 open ImIdentity
 open ImChat
-open ImRoom  
+open ImRoom
 open GuiColumns
 
 module U = GuiUtf8
@@ -40,6 +40,14 @@
 
 (*************************************************************************)
 (*                                                                       *)
+(*                         Global tables                                 *)
+(*                                                                       *)
+(*************************************************************************)
+
+let (act_by_num : (int, account) Hashtbl.t) = Hashtbl.create 13
+
+(*************************************************************************)
+(*                                                                       *)
 (*                         account_pixb                                  *)
 (*                                                                       *)
 (*************************************************************************)
@@ -71,6 +79,51 @@
 
 (*************************************************************************)
 (*                                                                       *)
+(*                         act_num                                       *)
+(*                                                                       *)
+(*************************************************************************)
+
+let act_num key =
+  try int_of_string key with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         act_of_key                                    *)
+(*                                                                       *)
+(*************************************************************************)
+
+let act_of_key key =
+  try
+    let num = act_num key in
+    Hashtbl.find act_by_num num
+  with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         keys_to_acts                                  *)
+(*                                                                       *)
+(*************************************************************************)
+
+let keys_to_acts keys =
+  let l = ref [] in
+  List.iter (fun k ->
+    try
+      let s = act_of_key k in
+      l := s :: !l
+    with _ -> ()) keys;
+  !l
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         act_key                                       *)
+(*                                                                       *)
+(*************************************************************************)
+
+let act_key act_num =
+  Printf.sprintf "%d" act_num
+
+(*************************************************************************)
+(*                                                                       *)
 (*                         Templates                                     *)
 (*                                                                       *)
 (*************************************************************************)
@@ -80,10 +133,9 @@
   module Column = GuiColumns.IMAccount
 
   type item = account
-  type key = int
 
   let columns = O.account_columns
-  let get_key = (fun ac -> account_num ac)
+  let get_key = (fun ac -> act_key (account_num ac))
   let module_name = "IM Accounts"
 
 end)
@@ -167,11 +219,15 @@
 (*                                                                       *)
 (*************************************************************************)
 
-  method sort_items c ac1 ac2 =
-    match c with
+  method sort_items c k1 k2 =
+    try
+      let ac1 = act_of_key k1 in
+      let ac2 = act_of_key k2 in
+      match c with
         Col_account_name -> compare (account_name ac1) (account_name ac2)
       | Col_account_status -> compare (account_status ac1) (account_status ac2)
       | Col_account_protocol -> compare (account_protocol ac1) (account_protocol ac2)
+    with _ -> 0
 
   end
 
@@ -263,16 +319,18 @@
 (*************************************************************************)
 
 let settings sel () =
+  let l = keys_to_acts sel in
   List.iter (fun account ->
      input_account account
-  ) sel
+  ) l
 
 let connect sel () =
+  let l = keys_to_acts sel in
   List.iter (fun account ->
     match account_status account with
         Status_offline -> account_login account
       | _ -> account_logout account
-  ) sel
+  ) l
 
 let remove sel () = ()
 
@@ -292,10 +350,10 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let account_menu (sel : account list) =
+let account_menu sel =
   match sel with
       [] -> []
-    | account :: tail ->
+    | k :: tail ->
         begin
           let basic_menu = 
             [
@@ -304,20 +362,23 @@
               `I (!M.iM_me_remove, remove sel) ;
             ]
           in
-          if tail = [] && account_has_rooms account then
-            (`I (!M.iM_me_join_room, (fun _ -> ask_for_room account)))::
-            (let prefered_rooms = account_prefered_rooms account in
-             if prefered_rooms = []
-               then []
-               else
-                 [ `M (!M.iM_me_prefered_rooms,
-                      List.map (fun name ->
-                          `I ((U.utf8_of name), (fun _ -> 
-                                account_join_room account name))  
-                      ) prefered_rooms)]
-              ) @basic_menu
-            else basic_menu
-        end
+          try
+            let account = act_of_key k in
+            if tail = [] && account_has_rooms account then
+              (`I (!M.iM_me_join_room, (fun _ -> ask_for_room account)))::
+              (let prefered_rooms = account_prefered_rooms account in
+               if prefered_rooms = []
+                 then []
+                 else
+                   [ `M (!M.iM_me_prefered_rooms,
+                        List.map (fun name ->
+                            `I ((U.utf8_of name), (fun _ -> 
+                                  account_join_room account name))
+                        ) prefered_rooms)]
+                ) @basic_menu
+              else basic_menu
+            with _ -> basic_menu
+          end
 
 (*************************************************************************)
 (*                                                                       *)
@@ -328,7 +389,8 @@
 let h_update_account account =
   lprintf' "h_update_account %d\n" (account_num account);
   try
-    let (row, ac) = accountstore#find_item (account_num account) in
+    let ac = act_of_key (act_key (account_num account)) in
+    let row = accountstore#find_row (act_key (account_num account)) in
     lprintf' "Updating Account %d\n" (account_num account);
     accountstore#update_item row ac account;
     lprintf' "Updated Account %d\n" (account_num account)
diff -urN src/gtk2/im/guiImRooms.ml src/gtk2/im/guiImRooms.ml
--- src/gtk2/im/guiImRooms.ml	2005-03-02 21:16:53.000000000 +0100
+++ src/gtk2/im/guiImRooms.ml	2005-09-18 17:02:55.000000000 +0200
@@ -39,6 +39,59 @@
 
 (*************************************************************************)
 (*                                                                       *)
+(*                         Global tables                                 *)
+(*                                                                       *)
+(*************************************************************************)
+
+let (id_by_num : (int, identity) Hashtbl.t) = Hashtbl.create 13
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         id_num                                        *)
+(*                                                                       *)
+(*************************************************************************)
+
+let id_num key =
+  try int_of_string key with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         id_of_key                                     *)
+(*                                                                       *)
+(*************************************************************************)
+
+let id_of_key key =
+  try
+    let num = id_num key in
+    Hashtbl.find id_by_num num
+  with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         keys_to_ids                                   *)
+(*                                                                       *)
+(*************************************************************************)
+
+let keys_to_ids keys =
+  let l = ref [] in
+  List.iter (fun k ->
+    try
+      let s = id_of_key k in
+      l := s :: !l
+    with _ -> ()) keys;
+  !l
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         id_key                                        *)
+(*                                                                       *)
+(*************************************************************************)
+
+let id_key id_num =
+  Printf.sprintf "%d" id_num
+
+(*************************************************************************)
+(*                                                                       *)
 (*                         Templates                                     *)
 (*                                                                       *)
 (*************************************************************************)
@@ -48,10 +101,9 @@
   module Column = GuiColumns.IMIdentities
 
   type item = identity
-  type key = int
 
   let columns = O.identities_columns
-  let get_key = (fun c -> identity_num c)
+  let get_key = (fun c -> id_key (identity_num c))
   let module_name = "IM Identities"
 
 end)
@@ -98,8 +150,12 @@
 (*                                                                       *)
 (*************************************************************************)
 
-    method sort_items c id1 id2 =
-      compare (String.lowercase (identity_name id1)) (String.lowercase (identity_name id2))
+    method sort_items c k1 k2 =
+      try
+        let id1 = id_of_key k1 in
+        let id2 = id_of_key k2 in
+        compare (String.lowercase (identity_name id1)) (String.lowercase (identity_name id2))
+      with _ -> 0
 
   end
 
@@ -140,8 +196,11 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let on_double_click_identity id =
-  identity_open_chat id
+let on_double_click_identity k =
+  try
+    let id = id_of_key k in
+    identity_open_chat id
+  with _ -> ()
 
 (*************************************************************************)
 (*                                                                       *)
@@ -192,16 +251,19 @@
 
 let update_identity id_new idstore =
   try
-    let (row, id) = idstore#find_item (identity_num id_new) in
-    idstore#update_item row id id_new
-  with _ -> 
-    ignore (idstore#add_item id_new)
+    let id = Hashtbl.find id_by_num (identity_num id_new) in
+    let row = idstore#find_row (id_key (identity_num id_new)) in
+    idstore#update_item row id id_new;
+    Hashtbl.replace id_by_num (identity_num id_new) id_new
+  with _ ->
+    begin
+      ignore (idstore#add_item id_new);
+      Hashtbl.add id_by_num (identity_num id_new) id_new
+    end
 
-let remove_identity id idstore = 
-  try
-    let (_, id) = idstore#find_item (identity_num id) in
-    idstore#remove_item id
-  with _ -> ()
+let remove_identity id idstore =
+  idstore#remove_item (id_key (identity_num id));
+  Hashtbl.remove id_by_num (identity_num id)
 
 let h_join_room room (note : GPack.notebook) =
   try
@@ -225,7 +287,8 @@
     ro.buffer#clear ();
     ro.store#clear ();
     ro.box#destroy ();
-    Hashtbl.remove rooms (room_num room)
+    Hashtbl.remove rooms (room_num room);
+    Hashtbl.clear id_by_num
   with _ -> ()
 
 let h_room_event room event =
